unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqlite3conn, sqldb, db, Forms, Controls, Graphics, Dialogs,
  StdCtrls, DBGrids, DBCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BtnCreateDB: TButton;
    BtnAddRow_SQLQuery_SQL: TButton;
    BtnAddRow_Pascal: TButton;
    BtnAddRow_Connection: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure BtnCreateDBClick(Sender: TObject);
    procedure BtnAddRow_SQLQuery_SQLClick(Sender: TObject);
    procedure BtnAddRow_PascalClick(Sender: TObject);
    procedure BtnAddRow_ConnectionClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.BtnCreateDBClick(Sender: TObject);
begin
  SQLite3Connection1.Connected := false;
  DeleteFile(SQLite3Connection1.DatabaseName);
  SQLite3Connection1.DatabaseName := 'sensordata.db';
  SQLite3Connection1.CreateDB;
  SQLIte3Connection1.ExecuteDirect(
    'CREATE TABLE xmpltbl ('+
      'id INTEGER PRIMARY KEY AUTOINCREMENT, ' +
      'currentdate TIME'+
    ')');
  SQLTransaction1.Commit;
  SQLQuery1.Open;
end;

procedure TForm1.BtnAddRow_SQLQuery_SQLClick(Sender: TObject);
begin
  SQLQuery1.Close;
  SQLQuery1.SQL.Clear;
  SQLQuery1.SQL.Add('INSERT INTO xmpltbl (currentdate) VALUES (:t)');
  SQLQuery1.Params.ParamByName('t').AsDateTime := Now - Random;
  SQLQuery1.ExecSQL;
  //SQLTransaction1.Commit;

  SQLQuery1.Close;
  SQLQuery1.SQL.Clear;
  SQLQuery1.SQL.Add('SELECT * FROM xmpltbl');
  SQLQuery1.Open;
end;

procedure TForm1.BtnAddRow_PascalClick(Sender: TObject);
begin
  SQLQuery1.Open;
  SQLQuery1.Append;
  SQLQuery1.FieldByName('currentdate').AsDateTime := Now - random;
  SQLQuery1.Post;
end;

procedure TForm1.BtnAddRow_ConnectionClick(Sender: TObject);
var
  s: String;
begin
  SQLite3Connection1.Connected := false;
  s := FormatDateTime('hh:nn:ss', Date() + Random);
  SQLite3Connection1.ExecuteDirect('INSERT INTO xmpltbl (currentdate) VALUES ("' + s + '")');
  SQLTransaction1.Commit;
  SQLQuery1.Open;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SQLite3Connection1.DatabaseName := 'sensordata.db';
  SQLite3Connection1.Transaction := SQLTransaction1;

  SQLQuery1.Transaction := SQLTransaction1;
  SQLQuery1.Options := SQLQuery1.Options + [sqoAutoApplyUpdates, sqoAutoCommit, sqoKeepOpenOnCommit];
  SQLQuery1.SQL.Add('SELECT * FROM xmpltbl');

  if FileExists(SQLite3Connection1.Databasename) then begin
    SQLQuery1.Open;

    // not absolutely necessary
    with DBGrid1.Columns.Add do begin
      Field := SQLQuery1.FieldByName('id');
      Alignment := taRightJustify;
      Width := 40;
    end;
    with DBGrid1.Columns.Add do begin
      Field := SQLQuery1.FieldByName('currentdate');
      Alignment := taCenter;
      Width := 100;
    end;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SQLTransaction1.Commit;
end;

end.

